<?php

class Routee_Logs {
    /**
     * @var
     */
    private $logdata;

    /**
     * @var
     */
    private $code;

    /**
     * @var
     */
    private $mode;

    /**
     * @param $mode
     * @param $code
     * @param $logdata
     */
    public function __construct($mode, $code, $logdata) {
		$this->mode = $mode;
		$this->code = $code; 
		$this->logdata = $logdata;

		$this->saveLogs();
        $this->sendErrorLog();
	}

    /**
     * @return void
     */
	public function saveLogs() {
		global $wpdb;
        global $wp;
		$table = $wpdb->prefix . 'store_events_logs';
        $isExported = get_option('routee_log_exported') ?? 0;
        $logType = ($this->code == 200) ? 1 : 0;
        $data = json_encode($this->logdata);
        $url = home_url($wp->request);
        $time = gmdate('d-m-Y H:i:s');
        $query = "INSERT INTO ".$table." (store_url,log_type,event_type,log_data,is_exported,created_at) VALUES ('$url','{$logType}','{$this->eventType()}','{$data}','{$isExported}','{$time}')";

		$wpdb->query($query);
	}

    /**
     * @return void
     */
    public function sendErrorLog() {
        global $wp;
        if($this->code != 200) {
            $postArr = array(
                'siteUrl' => home_url($wp->request),
                'uuid' => !empty(get_option('RouteeLoginCode')) ? get_option('RouteeLoginCode') : '',
                'event_name' => !empty($this->logdata['event']) ? $this->logdata['event'] : $this->logdata['mode'],
                'log_type' => 'failure',
                'log_data' => $this->logdata,
                'created_at' => gmdate('d-m-Y H:i:s'),
                'platform' => "WooCommerce"
            );

            $response = wp_remote_post(ROUTEE_ERR_LOG_URL, array(
                    'method'      => 'POST',
                    'httpversion' => '1.0',
                    'blocking'    => true,
                    'headers'     => array(),
                    'body'        => json_encode($postArr)
                )
            );

            wp_remote_retrieve_response_code( $response );
            json_decode( wp_remote_retrieve_body( $response ), TRUE );
        }
    }

    /**
     * @return int
     */
    public function eventType() {
        $type = 0;

        switch ($this->mode) {
            case "auth":
                $type = 1;
                break;
            case "data":
                $type = 3;
                break;
            case "event":
                $type = 2;
                break;
        }

        return $type;
    }
}