<?php
/*
Plugin Name: Routee
Description: Build campaigns, share content, engage clients via all available devices and messaging options. With Routee you can do the right thing at the right time making sure you deliver.
Version: 2.2.5
Author: WayMore.io
Author URI: https://waymore.io/
*/

if ( WP_DEBUG ) {
	error_reporting(E_ALL);
	ini_set('display_errors', 1);
}


if ( ! defined( 'ABSPATH' ) ) exit;

// If this file is called directly, abort.
if (!defined( 'WPINC')) die;

const ROUTEE_PLUGIN_VERSION = '2.2.5';

// Value can be prod or dev only cause all URLs depend on this value
const ROUTEE_ENV = 'prod';


const ROUTEE_AUTH_URL     = 'https://api.waymore.io/api/authenticate';

const ROUTEE_DATA_URL     = 'https://idata.routee.net/api/data';

const ROUTEE_EVENT_URL    = 'https://idata.routee.net/api/event';

const ROUTEE_EVENT2_URL   = 'https://workflows.routee.net/a9/waymore_events';

const ROUTEE_ERR_LOG_URL  = 'https://autoforms.routee.net/u001/log.php';

register_activation_hook(__FILE__,'Routee_Active');
/**
 * [Routee_Active]
 * @return void
 */
function Routee_Active(){
	global $wpdb;
	$table_name = $wpdb->prefix.'events';
	$create_tbl = "CREATE TABLE IF NOT EXISTS `{$table_name}` (
				  `id` int(11) NOT NULL AUTO_INCREMENT,
				  `event` varchar(455) NOT NULL,
				  `event_id` varchar(455) NOT NULL,
				  `req_msg` varchar(455) NOT NULL,
				  `is_valid` enum('0','1') NOT NULL,
				  `created_at` datetime NOT NULL,
				  `updated_at` datetime NOT NULL,
				  `json` text NOT NULL,
				  PRIMARY KEY (id)
				) ENGINE=MyISAM DEFAULT CHARSET=latin1";
	$wpdb->query($create_tbl);

	$log_table = $wpdb->prefix.'store_events_logs';
	$log_table_qry = "CREATE TABLE IF NOT EXISTS `{$log_table}` (
				  `id` bigint(20) NOT NULL AUTO_INCREMENT,
                  `store_url` varchar(256) NOT NULL,
				  `log_type` tinyint(4) NOT NULL COMMENT '0 for error, 1 for success',
				  `event_type` tinyint(4) NOT NULL COMMENT '1 = auth, 2 = mass data, 3 = events',
				  `log_data` longtext NOT NULL,
				  `is_exported` tinyint(4) NOT NULL DEFAULT '0' COMMENT '0 for no, 1 for yes',
				  `created_at` varchar(32) NOT NULL,
				  PRIMARY KEY (id)
				) ENGINE=MyISAM DEFAULT CHARSET=latin1";
	$wpdb->query($log_table_qry);
}

register_deactivation_hook( __FILE__, 'Routee_Deactive' );
/**
 * [Routee_Deactive]
 * @return void
 */
function Routee_Deactive(){
	
	Routee_http_call( 'event', array(),'Uninstall' );
	delete_option('RouteeLoginUser');
	delete_option('RouteeLoginPswd');
	delete_option('RouteeLoginCode');
	delete_option('RouteeAuthorized');
	delete_option('RouteeProductSynced');
	delete_option('RouteeCustomerSynced');
	delete_option('RouteeOrderSynced');
}

// Run all Routee hooks and functions
Routee_Functions();

/**
 * [Routee_Functions]
 * @return void
 */
function Routee_Functions(){
	include_once "function.php";
	include_once "Routee_Functions.php";
	$routee = new Routee_Functions();
}
